# Hunter's Bot Quota Addon
#  
# Install instructions:
#       1. Install Mattie's EventScripts 2.0 plugin:
#           http://mattie.info/cs/
#
#       2. Copy and upload this script to:
#           <gamedir>/addons/eventscripts/bot_quota/
#
#       3. Add the following line somewhere in autoexec.cfg:
#           es_load bot_quota
#
################################################################################
#import EventScripts
import es
#import Libraries
import random
import gamethread
import playerlib
import cmdlib

# Addon Information
info = es.AddonInfo()
info.name = "Bot Quota"
info.version = "2.0.1"
info.author = "Hunter"
info.url = "http://addons.eventscripts.com/addons/user/289"
info.description = "Keeps the bot_quota intact, made for Deathmatch servers"
info.basename = "bot_quota"

hunter_bot_quota_ver    = info.version
hunter_bot_quota_text   = 'Hunters '+info.name+', www.sourceplugins.de, '+info.version+', ES 2.0.0.250i+ (Python Version)'

# Server variables
bot_quota               = es.ServerVar('bot_quota')
bot_quota_mode          = es.ServerVar('bot_quota_mode')
bot_join_after_player   = es.ServerVar('bot_join_after_player')
bot_quota_rate          = es.ServerVar('bot_quota_rate', '5', 'How often should the bot_quota be checked? ( default = 5 )')

def load():
    public = es.ServerVar('hu_bq', info.version, info.name)
    public.makepublic()
    
    cmdlib.registerSayCommand('!bot_quota', _say_cmd, 'Change Bot Quota', 'bot_quota', 'ADMIN')
    cmdlib.registerSayCommand('!bot_quota_mode', _say_cmd_mode, 'Change Bot Quota Mode', 'bot_quota', 'ADMIN')
    
    gamethread.delayedname(int(bot_quota_rate), 'bot_quota', _check_quota)

    es.log(hunter_bot_quota_text)
    es.msg('#multi', '#green[BotQuota] #defaultLoaded')
    
def unload():
    gamethread.cancelDelayed('bot_quota')
    
    cmdlib.unregisterSayCommand('!bot_quota')
    cmdlib.unregisterSayCommand('!bot_quota_mode')
    
    es.msg('#multi', '#green[BotQuota] #defaultUnloaded') 

def es_client_command(event_var):
    if (str(event_var['command']) == '!hunter_bot_quota_ver') or (str(event_var['command']) == '!hunter_all_ver'):
        es.cexec(int(event_var['userid']), 'echo '+hunter_bot_quota_text)

def player_activate(event_var):
    gamethread.delayed(30, es.cexec, (int(event_var['userid']), 'echo '+hunter_bot_quota_text))

def _say_cmd(userid, args):
    if len(args) and args[0].isdigit():
        bot_quota.set(int(args[0]))

def _say_cmd_mode(userid, args):
    if len(args) and args[0] in ['normal', 'fill', 'match']:
        bot_quota_mode.set(args[0])

def _check_quota():
    gamethread.delayedname(int(bot_quota_rate), 'bot_quota', _check_quota)
    startquota = int(bot_quota)
    humans = len(playerlib.getUseridList('#human,#t')) + len(playerlib.getUseridList('#human,#ct'))
    bots = len(playerlib.getUseridList('#bot'))
    if (int(bot_join_after_player) == 0) or (int(bot_join_after_player) == 1 and humans > 0):
        if str(bot_quota_mode) == 'fill':
            total = int(bot_quota) - humans
        elif str(bot_quota_mode) == 'match':
            total = int(bot_quota) * humans
        else:
            total = int(bot_quota)
        if total > 0:
            total = total - bots
            if total > 0:
                temporary = {'t':0,'ct':0}
                for bot in range(0, int(total)):
                    if (len(playerlib.getUseridList('#bot,#t'))+temporary['t']) < (len(playerlib.getUseridList('#bot,#ct'))+temporary['ct']):
                        es.ServerCommand('bot_add_t')
                        temporary['t'] = temporary['t'] + 1
                    else:
                        es.ServerCommand('bot_add_ct')
                        temporary['ct'] = temporary['ct'] + 1
            elif total < 0:
                temporary = {'t':[],'ct':[]}
                for bot in range(0, int(total*-1)):
                    if (len(playerlib.getUseridList('#bot,#t'))-len(temporary['t'])) < (len(playerlib.getUseridList('#bot,#ct'))-len(temporary['ct'])):
                        botlist = playerlib.getUseridList('#bot,#ct')
                        for bot in botlist:
                            if bot in temporary['ct']:
                                botlist.remove(bot)
                        botid = random.choice(botlist)
                        es.ServerCommand('kickid '+str(botid))
                        temporary['ct'].append(botid)
                    else:
                        botlist = playerlib.getUseridList('#bot,#t')
                        for bot in botlist:
                            if bot in temporary['t']:
                                botlist.remove(bot)
                        botid = random.choice(botlist)
                        es.ServerCommand('kickid '+str(botid))
                        temporary['t'].append(botid)
        elif bots > 0:
            es.ServerCommand('bot_kick')
    es.ServerCommand('bot_quota '+str(startquota))
